



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>谈I/O模型</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">谈I/O模型</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 09:31:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>一个IO操作涉及两个系统对象：</p>
<ul><li>调用这个IO的用户Process/Thread</li>
<li>系统内核 - System Kernel</li></ul>
<p>一个具体的Read操作包括两个阶段：</p>
<ul><li>内核等待数据准备就绪：Waiting for the data to be ready</li>
<li>从内核向用户进程/线程拷贝数据：Copying the data from the Kernel to the Process/Thread</li></ul>
<blockquote><p>只有在同步的情况下才会有&ldquo;阻塞&rdquo;和&ldquo;非阻塞&rdquo;之说，异步情况，必须是非阻塞的！</p></blockquote>
<p>&ldquo;同步 - 异步&rdquo;指访问数据的一种协作方式，同步需要主动读写数据，在读写数据的过程中还是会阻塞；异步只需要I/O操作完成的通知，并不主动读写数据，由内核完成数据的读写。&ldquo;阻塞 - 非阻塞&rdquo;指进程/线程要访问的数据是否就绪，进程/线程是否需要等待。同步和异步着重点在于多个任务的执行过程中，一个任务的执行是否会导致整个流程的暂时等待，阻塞和非阻塞着重点在于发出一个请求操作时，如果进行操作的条件不满足是否会返会一个标志信息告知条件不满足。</p>
<p>同步/异步仅关注消息通知的方式，并不关心消息如何处理，消息处理过程中应用程序(线程)的状态用阻塞/非阻塞来描述，是函数/方法的实现方式。</p>
<p>参考：<a href="http://blog.csdn.net/bytxl/article/details/22692843" rel="external nofollow noreferrer">socket阻塞与非阻塞、同步与异步概念详解 - 1</a>；<a href="http://blog.csdn.net/hguisu/article/details/7453390" rel="external nofollow noreferrer">socket阻塞与非阻塞、同步与异步概念详解 - 2</a>；</p>
<h2>同步 vs 异步</h2>
<p>消息的通知机制，针对Client端（和Server端的交互），进程/线程触发IO操作后：</p>
<ul><li>同步：进程/线程等待IO操作完成（阻塞）或轮询查看IO操作是否完成（非阻塞）；</li>
<li>异步：直接返回，进程/线程做自己的事情，IO操作交给内核处理、完成后内核通知进程/线程；</li></ul>
<p>其中，异步中处理的执行部通过三种途径返回结果给调用者：</p>
<ul><li>状态：需要调用者定时检查，效率低；</li>
<li>通知：效率高；</li>
<li>回调函数：类似通知；</li></ul>
<p><strong>同步 Synchronous</strong></p>
<blockquote><p>A Synchronous-I/O operation causes the requesting process to be blocked until that I/O operation completes.</p></blockquote>
<p>　串行，无条件等待，具体见下前4种I/O。</p>
<p><strong>异步 Asynchronous</strong></p>
<blockquote><p>An Asynchronous-I/O operation does not cause the requesting process to be blocked.</p></blockquote>
<p>　并发，无需等待、无需轮询，具体见下异步I/O。</p>
<h2>阻塞 vs 非阻塞</h2>
<p>应用程序在等待消息时的状态，针对Server端，Server端是否阻塞与Client端无关，至于Client端在等待的前提下啥也不做还是边做其他事边等待，由Client端自己决定。关于阻塞/非阻塞，在网络编程中通常应用在是不是需要等待数据就绪。</p>
<p><strong>阻塞 Blocking</strong></p>
<p>　挂起等待，具体见下阻塞I/O。</p>
<p><strong>非阻塞 Non-Blocking</strong></p>
<p>　轮询检查等待，具体见下非阻塞I/O。</p>
<p>参考：<a href="http://www.zhihu.com/question/19732473#" rel="external nofollow noreferrer">怎样理解阻塞非阻塞与同步异步的区别？ - 知乎</a>；</p>
<h2>I/O模型</h2>
<p><strong>阻塞I/O</strong>（Blocking I/O）</p>
<p>进程阻塞等待，进程挂起睡眠直到数据拷贝完成。</p>
<p>简单易实现，不适于同时处理大量套接字、扩展性差。改进：</p>
<ul><li>多进程/线程；</li>
<li>线程池或连接池；</li></ul>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161026205916762" /></p>
<p><strong>非阻塞I/O</strong>（Non-Blocking I/O）</p>
<p>进程非阻塞等待，数据准备阶段进程不睡眠而是轮询等待（导致CPU占用率高）、数据拷贝阶段进程阻塞。</p>
<p>便于处理多套接字的通信，但实现复杂、需仔细检查返回代码并对收到的错误信息进行处理。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161026205928356" /></p>
<p><strong>I/O多路复用</strong>（I/O Multiplexing）&nbsp;<strong>Reactor模式</strong></p>
<p>对一个IO端口，两次调用、两次返回。</p>
<p>数据准备阶段进程阻塞等待于select()/epoll()、数据拷贝阶段进程阻塞，其中select()可以同时阻塞多个I/O端口的操作，直到某个端口有数据可读/写时，才真正调用I/O操作函数。 实现同时对多个IO端口进行监听，适于处理大量套接字的连接。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161026205935814" /></p>
<p>I/O多路复用经典模式（2种）：</p>
<ul><li>基于同步I/O的<strong>Reactor</strong></li>
<li>基于异步I/O的<strong>Proactor</strong></li></ul>
<p>参考：<a href="http://www.cnblogs.com/dawen/archive/2011/05/18/2050358.html" rel="external nofollow noreferrer">Reactor和Proactor</a>；</p>
<p><strong>信号驱动I/O</strong>（Signal Driven I/O）</p>
<p>两次调用，两次返回。</p>
<p>数据准备阶段进程继续执行、数据拷贝阶段进程阻塞。 需要建立信号处理程序。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161026205944544" /></p>
<p><strong> 异步I/O</strong>（Asynchronous I/O）&nbsp;<strong>Proactor模式</strong></p>
<p><strong>&nbsp;</strong>无阻塞，无需等待、无需轮询、无需多线程。</p>
<p>异步过程调用，调用者不能立刻得到结果，实际处理这个调用的部件在完成处理后，通过状态、通知或回调来通知调用者。异步需操作系统的底层支持。</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161026205954841" /></p>
<p><strong>注</strong>：信号驱动模型由内核通知用户可以开始一个IO操作(数据在内核缓冲区中)，异步IO由内核通知IO操作已经完成(数据已在用户空间中)。</p>
<p><strong>比较</strong></p>
<p>同步IO - 异步IO：数据访问时的消息通知机制，数据访问/拷贝时（第二阶段）进程是否等待，主动等待还是被动通知等待消息的触发！&nbsp;同步IO和异步IO的关键区别反映在数据拷贝阶段是由用户线程完成还是内核完成。</p>
<p>阻塞IO - 非阻塞IO：等待数据就绪时（第一阶段）应用程序的调用是否立即返回！</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20161029172218708" /></p>
<p>推荐书籍：</p>
<ul><li>Richard Stevens -《UNIX网络编程 - 卷1》：第六章</li></ul>
<p>参考：</p>
<ul><li><a href="http://www.cnblogs.com/Anker/p/3254269.html" rel="external nofollow noreferrer">我和女友解释I/O模型</a>；</li>
<li><a href="http://www.cnblogs.com/dolphin0520/p/3916526.html" rel="external nofollow noreferrer">Java NIO：浅析I/O模型 - 海子</a>；</li>
<li><a href="http://www.importnew.com/21383.html" rel="external nofollow noreferrer">Java I/O 模型的演进</a>；&nbsp;<a href="http://www.rowkey.me/blog/2016/01/18/io-model/" rel="external nofollow noreferrer">也谈IO模型</a>；</li>
<li><a href="http://blog.csdn.net/historyasamirror/article/details/5778378" rel="external nofollow noreferrer">IO - 同步，异步，阻塞，非阻塞 （亡羊补牢篇）</a>；</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q2xgmw9.html">python 3&period;5&period;2 install pillow</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkkkj9.html">最全面的 C&plus;&plus; 资源、框架大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gxo6zq.html">JAVA CDI 学习&lpar;4&rpar; - &commat;Alternative&sol;&commat;Default&sol;&commat;Any &amp;amp&semi; Extension</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96gxpy8.html">php----显示中文乱码的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7524j9.html">更改appstore开发商名字</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k10nkj9.html">&lbrack;Ubuntu&rsqb; Ubuntu14&period;04 64bit 编译安装nginx1&period;7&plus;php5&period;4&plus;mysql5&period;6</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xg46v8.html">浅谈Java的包装类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm1d619.html">db2查询锁表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02gx0q.html">找啊找啊找GF</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok2zxx9.html">一步步学习NHibernate&lpar;2&rpar;&amp;mdash&semi;&amp;mdash&semi;配置NHibernate的环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1znl629.html">jquery ajax 的data 存表单的值</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w1koxq.html">Unity 的&OpenCurlyDoubleQuote;Vertex Lit Rendering path&OpenCurlyDoubleQuote;中 shader Pass 的注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xer408.html">Dede 列表文章 自增</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meerv0q.html">SDUTOJ 1298 活动选择</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoyym1q.html">SQL Server 得到SPID&comma;唯一的sessionID</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1yrpmq.html">SQLServer 2005 数据库定阅复制实现双机热备（主要是sharepoint 内容数据库）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pyg4v8.html">Segmentation Faul</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kd7e59.html">python中的if  &lowbar;&lowbar;name&lowbar;&lowbar;&equals;&equals;&amp;&num;39&semi;&lowbar;&lowbar;main&lowbar;&lowbar;&amp;&num;39&semi;&colon;     main&lpar;&rpar;解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z55xe9.html">【深度学习篇】--神经网络中的池化层和CNN架构模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljzn319.html">小程序展开收缩文字demo</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9j1mzw9.html">Android应用安全开发之浅谈网页打开APP</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqll1v1q.html">ABP理论学习之发布说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnvd5j8.html">给Mac OS X的&OpenCurlyDoubleQuote;逻辑宗卷组&rdquo;改名</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kjnoj9.html">当程序以Windows Services形式启动时当前路径不对</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93wd3gq.html">ystep jQuery流程、步骤插件</a>
			</li>
						<li><a href="https://www.batexi.com/a/39r5yldq.html">I&sol;O重定向的原理和实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnv5538.html">TODO：关于自媒体博客改名</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7on0j8.html">《Entity Framework 6 Recipes》中文翻译系列 &lpar;43&rpar; ------ 第八章 POCO之使用POCO加载实体</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m2wxoq.html">Atitit webservice的发现机制 discover机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7o0vj8.html">Windows phone重写返回键</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
